-- written by DaddelZeit
-- DO NOT USE WITHOUT PERMISSION

local M = {}
local jsonData = {}

local function onExtensionLoaded()
    jsonData = jsonReadFile("/scripts/BetterStarter/inject/register.json")
    if jsonData.curGameVer then
        if not beamng_versionb:match(tostring(jsonData.curGameVer)) then
            local modname = jsonData.modUIName
            guihooks.trigger('toastrMsg', {
                type = "warning",
                title = modname or "Unknown mod",
                msg = "Aborted mod load due to possibly incompatible game version. Consider disabling the mod.",
                config = {
                    timeOut = 10000,
                    progressBar = true,
                    closeButton = true,

                    -- default stuffs
                    positionClass = 'toast-top-right',
                    preventDuplicates = false,
                    preventOpenDuplicates = false,
                }
            })
            return
        end
    end

    for _, file in pairs(jsonData.files) do
        FS:copyFile("scripts/BetterStarter/inject/"..file, file)
    end
end

local function onExit()
    for _, file in pairs(jsonData.files) do
        FS:remove(file)
    end
end

M.onExtensionLoaded = onExtensionLoaded
M.onExit = onExit

return M